//
// Cognitive radio simulator
//

#ifndef __COGNITIVE_RADIO_TEST_H__
#define __COGNITIVE_RADIO_TEST_H__

#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <sigprocc/sigprocc.h>

typedef struct metadata_t * metadata;

// transmitter thread
void execute_tx(
        metadata _md,
        char *_msg_in,
        unsigned int _msg_len,
        float * _I,
        float *_Q,
        unsigned int *_sym_len);

// channel thread
void execute_channel(metadata _md, float _std, float * _I, float *_Q, unsigned int _len);

// receiver thread
void execute_rx(
        metadata _md,
        float * _I,
        float *_Q,
        unsigned int _sym_len,
        char *_msg_out,
        unsigned int *_msg_len);

// count bit errors
unsigned int count_errors(char * _msg_in, char * _msg_out, unsigned int _num_bits);

struct metadata_t {
    modulation_scheme mod_scheme;
    unsigned int mod_bps;
    float tx_power_dBW;
    //unsigned int packet_size;
    float symbol_rate;
};


#endif // __COGNITIVE_RADIO_TEST_H__
